Bug 961044 - mdmonitor misuses argv[0][0] = '@' logic
mdmonitor misuses argv[0][0] = '@' logic
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: mdadm (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jes Sorensen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-08 11:33 EDT by Lennart Poettering
Modified: 2015-02-17 10:11 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 10:11:42 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Lennart Poettering 2013-05-08 11:33:59 EDT
I noticed that mdmonitor sets argv[0][0] to '@' even when run from the root partition. That's explicitly not how it should be used. If something is run from the rootfs, then it needs to be killed normally at shutdown, before we unmount the root dir. Only if something is run from the initrd and hence is independent of the rootfs it can stay around.

This is actually explicitly made clear in 

http://www.freedesktop.org/wiki/Software/systemd/RootStorageDaemons
Comment 1 Jes Sorensen 2013-05-15 07:29:55 EDT
We set '@' because systemd should never kill mdmon under any circumstances,
whether the array is assembled from the initramfs root or post that.

Getting rid of the --offroot argument allowed us to avoid having different
systemd scripts for launching mdmon depending on whether it was launched
from dracut or not.

I don't see how putting this script mess back in place is going to make this
any cleaner, or do you have something magic suggestion up your sleeve for it?

Thanks,
Jes
Comment 2 Lennart Poettering 2013-05-15 14:23:10 EDT
(In reply to comment #1)
> We set '@' because systemd should never kill mdmon under any circumstances,
> whether the array is assembled from the initramfs root or post that.

This cannot work. We do not support this. You cannot manage a disk with a daemon that runs from the disk you manage.

If you need a daemon to manage the root file system, then this daemon needs to run from the initrd. There is no other clean way, and we do not support anything else.

I am going change systemd to ignore the '@' setting for processes run from the root fs. I will also add a warning for cases like this.

THe wiki page has been clear about this from day #1.

> Getting rid of the --offroot argument allowed us to avoid having different
> systemd scripts for launching mdmon depending on whether it was launched
> from dracut or not.
> 
> I don't see how putting this script mess back in place is going to make this
> any cleaner, or do you have something magic suggestion up your sleeve for it?

The wiki text suggests to check for /etc/initrd-release. That file exists in initrds, but not on the system. See the second example on the wiki page.
Comment 3 Fedora End Of Life 2015-01-09 13:04:39 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2015-02-17 10:11:42 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.